grammar Proof;

import EquationRules;

/*
 * Parser Rules
 */

proof      : lemma* mainProof lemma* EOF ;
mainProof  : 'proof' singleProof proof_end? ;
lemma      : lemmaDef singleProof ;
lemmaDef   :'lemma' BEZ ':' eq ;
singleProof: induction | transformation ;
proof_end  : 'q.e.d.' | 'w.z.b.w.' | 'Q.E.D.' | 'W.Z.B.W.';

// Induction
induction: ind_var? ind_basis+ ind_hyp+ ind_step* ;
ind_var  : 'induction' BEZ ;
ind_basis: 'IA' ':'? ind_case transformation ;
ind_step : 'IS' ':'? ind_case transformation ;
ind_case : 'zu zeigen:' eq ;
ind_hyp  : 'IH' ':'? (BEZ ':'?)?  eq;

// Transformation
transformation     : start_tree transformation_step+ ;
start_tree         : mytree ;
transformation_step: '{' axiom',' direction ',' termpart ',' subst '}' '=' result_tree ;
axiom              : BEZ | 'IH';
direction          : ( 'lr' | 'rl' ) ;
termpart           : mytree ;
subst              : '[' (sub (',' sub)*)? ']' ;
sub                : mytree '/' BEZ ;
result_tree        : mytree ;

