﻿using System.Collections.Generic;

namespace Eingabeverwaltung.Metamodell
{
    public class TaskAssignment
    {
        public readonly SingleTask task;
        private List<Constructor> indCases;

        public TaskAssignment(SingleTask task)
        {
            this.task = task;
            indCases = new List<Constructor>();
        }

        public List<Constructor> IndCases
        {
            get { return new List<Constructor>(indCases); }
        }

        public void AddIndCase(Constructor c) { if (!indCases.Contains(c)) indCases.Add(c); }

        public override string ToString()
        {
            string res = task.name;
            if (indCases.Count > 0)
            {
                res += " ( ";
                foreach (Constructor indC in indCases)
                    res += indC.name + " ";
                res += ")";
            }
            return res;
        }
    }
}
