﻿using Ueberpruefung;
using System.Collections.Generic;

namespace Testverwaltung
{
	public class TransformationTest : Test
	{
		private List<string> shouldValues;

		public TransformationTest() : base()
		{
			numTests = 15;
			shouldValues = new List<string>();
			string err = "";
			string errO = "[ inc( n ) / n ]";
			for (int ts = -1, sub = -1, error = 1; error < numTests; error++)
			{
                switch (error)
                {
					case 3:  err = aus.ErrorMessage(new List<Error>() { new Error(error)                   }, 1 , 2  ); ts = 1; break;
					case 4:  err = aus.ErrorMessage(new List<Error>() { new Error(error)                   }, 1 , 1  );         break;
					case 5:  err = aus.ErrorMessage(new List<Error>() { new Error(error)                   }, 1 , sub)+
								   aus.ErrorMessage(new List<Error>() { new Error(error)                   }, 2 , sub);         break;
					case 6:  err = aus.ErrorMessage(new List<Error>() { new Error(6),new Error(7)          }, 2 , sub);         break;
					case 8:  err = aus.ErrorMessage(new List<Error>() { new Error(error)                   }, 2 , sub);         break;
					case 9:  err = aus.ErrorMessage(new List<Error>() {              new Error(error,errO) }, ts, sub);         break;
					case 10: err = aus.ErrorMessage(new List<Error>() { new Error(8),new Error(error,errO) }, ts, sub);         break;
					case 12: err = aus.ErrorMessage(new List<Error>() { new Error(8),new Error(error)      }, ts, sub);         break;
					case 13: err = aus.ErrorMessage(new List<Error>() { new Error(error)                   }, 1 , 2  );         break;
					default: err = aus.ErrorMessage(new List<Error>() { new Error(error)                   }, ts, sub);         break;
				}
				shouldValues.Add("Hauptbeweis\r\n" + err);
			}
		}
		public override bool run()
        {
			string path = "Tests\\simpl\\";
			resultString = "Testing Finding Errors in Transformation\r\n\r\n";
			ein.Eingabe_Interface("ADT", path + "ADT_Bsp.adt");
			ein.Eingabe_Interface("Task", path + "Task_Bsp.task");
			ein.Eingabe_Interface("Proof", path + "Proof_correct.proof");
			Ueberpruefer.ueberpruefe(ein.GetContainer());
			resultString += assert(0, aus.NoErrors(), aus.printAllErrors(ein.GetContainer()));
			for (int error = 1; error < numTests - 1; error++)
			{
				ein.Eingabe_Interface("Proof", path + "Proof_error_" + error + ".proof");
				Ueberpruefer.ueberpruefe(ein.GetContainer());
				resultString += assert(error, shouldValues[error - 1], aus.printAllErrors(ein.GetContainer()));
			}
			ein.Eingabe_Interface("Proof", path + "Proof_correct_rl.proof");
			Ueberpruefer.ueberpruefe(ein.GetContainer());
			resultString += assert(14, aus.NoErrors(), aus.printAllErrors(ein.GetContainer()));
			return passed;
		}
	}
}
