﻿using Eingabeverwaltung.Metamodell;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 33
    /// @pre: constructors of cases must be set
    /// </summary>
    public class CheckIndCaseTypeIsValid : ElementChecker
    {
        /// <summary>
        /// checks error 33
        /// @pre: constructors of cases must be set
        /// </summary>
        public CheckIndCaseTypeIsValid() : base() { }
        public override bool check(Element e)
        {
            if (e is Induction ind)
            {
                if (ind.indVar == null) return true;
                List<InductionCase> invalidCases = new List<InductionCase>();
                for (int i1 = 0; i1 < ind.indCases.Count; i1++)
                { 
                    InductionCase ic1 = ind.indCases[i1];
                    if (ic1.Constructor == null) { if (!invalidCases.Contains(ic1)) invalidCases.Add(ic1); }
                    else
                        for (int i2 = i1 + 1; i2 < ind.indCases.Count; i2++)
                        {
                            InductionCase ic2 = ind.indCases[i2];
                            if (ic1.Constructor == ic2.Constructor)
                                if (!invalidCases.Contains(ic2)) invalidCases.Add(ic2);
                        }
                }
                foreach (InductionCase ic in invalidCases)
                    ic.errors.Add(new Error(33));
                return invalidCases.Count == 0;
            }
            else throw new InvalidOperationException();
        }
    }
}
