﻿using Eingabeverwaltung.Metamodell;
using System;
using System.Collections.Generic;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 32
    /// @pre: constructors of cases must be set
    /// </summary>
    public class CheckIndCasesAllExisting : ElementChecker 
    {
        /// <summary>
        /// checks error 32
        /// @pre: constructors of cases must be set
        /// </summary>
        public CheckIndCasesAllExisting() : base() { }
        public override bool check(Element e)
        {
            if (e is Induction ind)
            {
                if (ind.indVar == null) return true;
                List<Constructor> indCasesCs = new List<Constructor>();
                foreach (InductionCase indCase in ind.indCases) indCasesCs.Add(indCase.Constructor);
                List<Constructor> indVarCs = new List<Constructor>(ind.indVar.sort.GetConstructors());
                for (int iVC = 0; iVC < indVarCs.Count; iVC++)
                    if (indCasesCs.Contains(indVarCs[iVC])) { indVarCs.RemoveAt(iVC); iVC--; }
                if (indVarCs.Count != 0) 
                {
                    string output = "";
                    foreach (Constructor indVarC in indVarCs) output += indVarC.name + " ";
                    ind.errors.Add(new Error(32, output));
                    return false;
                }
                else return true;
            }
            else throw new InvalidOperationException();
        }
    }
}
